
'slave prog for Parallel computing
'Henk Verbeek, Amsterdam the Netherlands 2015
'Mandelbrot part from LOKI backshed forum

CPU 48
Option autorun on
I2C slave close
SetPin 2,dout:SetPin 3,dout:SetPin 4,dout 'SET led pins
SetPin 5,din,pulldown:SetPin 6,din,pulldown:SetPin 14,din,pulldown:SetPin 15,din,pulldown 'set address pins
SetPin 24,din,pulldown:SetPin 25,din,pulldown:SetPin 26,din,pulldown 'set address pins
get_address 'let slave calculate its hardwired address

mag$=""
maxit=0
start=0:start2=0
I2C slave open address_slave,0,0,writed,readd

Pin(2)=1 'LED on so prog is waiting for action

Do 
Print "Waiting commands" 'these print commands are not necessary can be deleted
Print ""
Loop Until maxit<>0

Pin(2)=0 'led waiting off
Pin(4)=1 'led start action on

mandelbrot 'go calculate fractal
Pause 10000
Print "calculation complete!" 'print commands is not necessary can be deleted
Pin(4)=0 'start LED off 
Pin(3)=1 'ready LED on
I2C slave close
End


readd:
If start2=0 Then recvar 'reading variables
IReturn

writed:
I2C slave write 9,mag$ 'sending results to master
yc=999
IReturn

Sub recvar 'reading variables
start2=1
Pause 10
I2C slave read 5,var$,recvd
slaves=Val(var$)
Pause 10
I2C slave read 5,var$,recvd
Pause 10
realoffset=Val(var$)
Pause 10
I2C slave read 5,var$,recvd
imaginoffset=Val(var$)
Pause 10
I2C slave read 5,var$,recvd
crealval=Val(var$)
Pause 10
I2C slave read 5,var$,recvd
cimagval=Val(var$)
Pause 10
I2C slave read 5,var$,recvd
maxit=Val(var$)
End Sub

Sub mandelbrot 
pixelwidth=480
pixelheight=432
gap=pixelheight/pixelwidth
size=0.9
xdelta=size/pixelwidth
ydelta=(size*gap)/pixelheight
endplot=(pixelheight/slaves)*(address_slave-7)
startplot=(pixelheight/slaves)*(address_slave-7)-pixelheight/slaves

For x=0 To (pixelwidth-1)
cx= x*xdelta+realoffset
For y=startplot To endplot
cy=y*ydelta+imaginoffset
zr=cx
zi=cy
count=0

Do While ((count <= maxit) And ((zr*zr+zi*zi) <4))
new_zr=zr*zr-zi*zi+crealval
new_zi=2*zr*zi+cimagval
zr=new_zr
zi=new_zi
count=count+1
Loop
c1=count Mod 8
fx$="":fy$=""
If x<10 Then fx$="  "
If x<100 And x>=10 Then fx$=" "
If y<10 Then fy$="  "
If y<100 And y>=10 Then fy$=" "
mag$=Str$(x)+fx$+","+Str$(y)+fy$+","+Str$(c1)
yc=y
Do
Loop Until yc<>y
Next y
Next x
mag$="999,999,9"
End Sub

Sub get_address
address$="&b"+Str$(Pin(5))+Str$(Pin(6))+Str$(Pin(14))+Str$(Pin(15))+Str$(Pin(24))+Str$(Pin(25))+Str$(Pin(26))
address_slave=Val(address$)
End Sub
